-- Drunk Fish Deluxe, by Thortok2000
-- Second addon I ever made from scratch, so be nice!

	local _, SPIRIT_OF_HARMONY = GetItemInfo(76061)
	local _, SONGBELL_SEED = GetItemInfo(89233)
	local BestTokenValue = 0
	local BestTokenValueName = ""
	local BestSpiritValue = 0
	local BestSpiritValueName = ""
	local BestSeedValue = 0
	local BestSeedValueName = ""
	local RecommendedValue = 0
	local RecommendedName = ""
	local DFD_TokenTimer = nil
	local DFD_SpiritTimer = nil
	local DFD_SeedTimer = nil
	local bonusintro = false
	local PricingDataLoaded = time()


function DFD_OnLoad(self)
	self:RegisterEvent("ZONE_CHANGED");						
	self:RegisterEvent("ZONE_CHANGED_INDOORS");
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA");
	self:RegisterEvent("PLAYER_LOGIN");

end

function DFD_JoguWhispers(message) -- Thanks to Choonster from the WoW UI forums for the code for this function.
	local mwc = ChatTypeInfo["MONSTER_WHISPER"] -- Get the mwc (Monster Whisper Color) table for MONSTER_WHISPER messages
	DEFAULT_CHAT_FRAME:AddMessage("Jogu the Drunk whispers: "..message, mwc.r, mwc.g, mwc.b) -- Add a chat message using the RGB values from the mwc table
end

function DFD_OnEvent(self, event, arg1)
	if ( event == "PLAYER_LOGIN" ) then
		
		_, SPIRIT_OF_HARMONY = GetItemInfo(76061)
		_, SONGBELL_SEED = GetItemInfo(89233)
		DFD_LoginZone = GetMinimapZoneText()
		if IsAddOnLoaded("Auc-Advanced") then
			DFD_JoguWhispers("Using Auctioneer Advanshed for pricing data!")
			PricingDataLoaded = time()
		elseif not IsAddOnLoaded("Auc-Advanced") then
			DFD_JoguWhispers("You musht load Auctioneer Advanshed for thish addon to work properly!  ..hic!")
		end
		
	elseif ( event == "ZONE_CHANGED" or event == "ZONE_CHANGED_INDOORS" or event == "ZONE_CHANGED_NEW_AREA" ) and ( time() > 10 + PricingDataLoaded ) then
		if ( GetMinimapZoneText() == "The Summer Terrace" or GetMinimapZoneText() == "The Golden Terrace" ) then
			RecommendedValue, RecommendedName = DFD_SpiritValue()
			RaidNotice_AddMessage( RaidBossEmoteFrame, "The Drunk Fish Recommends: Use "..SPIRIT_OF_HARMONY.." to buy "..RecommendedName, ChatTypeInfo["RAID_BOSS_EMOTE"] )
			if (DFD_SpiritTimer == nil or time() > 120 + DFD_SpiritTimer) then
				DFD_JoguWhispers("Ushe your "..SPIRIT_OF_HARMONY.." to buy "..RecommendedName.." for a total (hic) profit of "..DFD_GetMoneyString(RecommendedValue).." each!  ..(hic)")
				DFD_SpiritTimer = time()
			end
		elseif ( GetMinimapZoneText() == "Sunsong Ranch" ) then
			RecommendedValue, RecommendedName = DFD_SeedValue()
			RaidNotice_AddMessage( RaidBossEmoteFrame, "The Drunk Fish Recommends: "..RecommendedName, ChatTypeInfo["RAID_BOSS_EMOTE"] )
			if (DFD_SeedTimer == nil or time() > 120 + DFD_SeedTimer) then
				DFD_JoguWhispers("I shuggesht you plant shome " ..RecommendedName.. " for an average (hic) value of " .. DFD_GetMoneyString(RecommendedValue) .. " per sheed!")
				local _, CARROT_CHECK = GetItemInfo(74841)
				if RecommendedName == CARROT_CHECK then
					DFD_JoguWhispers("Mmmm...Carrotsh...")
				end
				DFD_JoguWhispers("If you plant 16 of theshe today, tomorrow you'll make an average antishipated profit of " .. DFD_GetMoneyString( 16 * RecommendedValue) .. "!  (hic) I think...")
				bonusintro = false
				DFD_BonusSeedValue()
				DFD_SeedTimer = time()
			end
			if bonusintro then
				RaidNotice_AddMessage( RaidBossEmoteFrame, "But if the Waters say otherwise, then plant one of these: "..totallinkstring, ChatTypeInfo["RAID_BOSS_EMOTE"] )
			end
		elseif ( GetMinimapZoneText() == "The Halfhill Market" ) then
			RecommendedValue, RecommendedName = DFD_IronPawTokenValue()
			RaidNotice_AddMessage( RaidBossEmoteFrame, "The Drunk Fish Recommends: Convert IronPaw Token into "..RecommendedName, ChatTypeInfo["RAID_BOSS_EMOTE"] )
			if (DFD_TokenTimer == nil or time() > 120 + DFD_TokenTimer) then
				DFD_JoguWhispers("Shwap your IronPaw Token for "..RecommendedName.. " for a total profit of " .. DFD_GetMoneyString(RecommendedValue).." (hic) each!")
				DFD_TokenTimer = time()
			end
		else
			DFD_LoginZone = ""
		end
	end
end

function DFD_GetPrice(itemID)
	if IsAddOnLoaded("Auc-Advanced") ~= nil then
		if AucAdvanced.Modules.Util.Appraiser.GetPrice(itemID) ~= nil then
			return AucAdvanced.Modules.Util.Appraiser.GetPrice(itemID)
		elseif AucAdvanced.API.GetMarketValue(itemID) ~= nil then
			DFD_JoguWhispers("You should get the Appraiser module for Auctioneer Advanced!")
			return AucAdvanced.API.GetMarketValue(itemID)
		end
	end
	return 0
end

function DFD_GetMoneyString(money)  -- Code for this function taken from the addon 'Postal'.  Thanks!
	local gold = floor(money / 10000)
	local silver = floor((money - gold * 10000) / 100)
	local copper = mod(money, 100)
	if gold > 0 then
		return format(GOLD_AMOUNT_TEXTURE.." "..SILVER_AMOUNT_TEXTURE.." "..COPPER_AMOUNT_TEXTURE, gold, 0, 0, silver, 0, 0, copper, 0, 0)
	elseif silver > 0 then
		return format(SILVER_AMOUNT_TEXTURE.." "..COPPER_AMOUNT_TEXTURE, silver, 0, 0, copper, 0, 0)
	else
		return format(COPPER_AMOUNT_TEXTURE, copper, 0, 0)
	end
end

function DFD_IronPawTokenValue()
	BestTokenValue = 0
	if DFD_GetPrice(74661) > BestTokenValue then		
		BestTokenValue = DFD_GetPrice(74661)
		_, BestTokenValueName = GetItemInfo(74661) -- "Black Pepper"
	end
	if DFD_GetPrice(74662) > BestTokenValue then		
		BestTokenValue = DFD_GetPrice(74662)
		_, BestTokenValueName = GetItemInfo(74662) -- "Rice Flour"
	end
	if ( DFD_GetPrice(74833) * 5 ) > BestTokenValue then		
		BestTokenValue = ( DFD_GetPrice(74833) * 5 )
		_, BestTokenValueName = GetItemInfo(74833) -- "Raw Tiger Steak (x5)"
		BestTokenValueName = BestTokenValueName.." (x5)"
	end
	if ( DFD_GetPrice(74834) * 5 ) > BestTokenValue then		
		BestTokenValue = ( DFD_GetPrice(74834) * 5 )
		_, BestTokenValueName = GetItemInfo(74834) -- "Mushan Ribs (x5)"
		BestTokenValueName = BestTokenValueName.." (x5)"
	end
	if ( DFD_GetPrice(74837) * 5 ) > BestTokenValue then		
		BestTokenValue = ( DFD_GetPrice(74837) * 5 )
		_, BestTokenValueName = GetItemInfo(74837) -- "Raw Turtle Meat (x5)"
		BestTokenValueName = BestTokenValueName.." (x5)"
	end
	if ( DFD_GetPrice(74838) * 5 ) > BestTokenValue then		
		BestTokenValue = ( DFD_GetPrice(74838) * 5 )
		_, BestTokenValueName = GetItemInfo(74838) -- "Raw Crab Meat (x5)"
		BestTokenValueName = BestTokenValueName.." (x5)"
	end
	if ( DFD_GetPrice(74839) * 5 ) > BestTokenValue then		
		BestTokenValue = ( DFD_GetPrice(74839) * 5 )
		_, BestTokenValueName = GetItemInfo(74839) -- "Wildfowl Breast (x5)"
		BestTokenValueName = BestTokenValueName.." (x5)"
	end
	if ( DFD_GetPrice(74840) * 25 ) > BestTokenValue then		
		BestTokenValue = ( DFD_GetPrice(74840) * 25 )
		_, BestTokenValueName = GetItemInfo(74840) -- "Green Cabbage (x25)"
		BestTokenValueName = BestTokenValueName.." (x25)"
	end
	if ( DFD_GetPrice(74841) * 25 ) > BestTokenValue then		
		BestTokenValue = ( DFD_GetPrice(74841) * 25 )
		_, BestTokenValueName = GetItemInfo(74841) -- "Juicycrunch Carrot (x25)"
		BestTokenValueName = BestTokenValueName.." (x25)"
	end
	if ( DFD_GetPrice(74842) * 25 ) > BestTokenValue then		
		BestTokenValue = ( DFD_GetPrice(74842) * 25 )
		_, BestTokenValueName = GetItemInfo(74842) -- "Mogu Pumpkin (x25)"
		BestTokenValueName = BestTokenValueName.." (x25)"
	end
	if ( DFD_GetPrice(74843) * 25 ) > BestTokenValue then		
		BestTokenValue = ( DFD_GetPrice(74843) * 25 )
		_, BestTokenValueName = GetItemInfo(74843) -- "Scallions (x25)"
		BestTokenValueName = BestTokenValueName.." (x25)"
	end
	if ( DFD_GetPrice(74844) * 25 ) > BestTokenValue then		
		BestTokenValue = ( DFD_GetPrice(74844) * 25 )
		_, BestTokenValueName = GetItemInfo(74844) -- "Red Blossom Leek (x25)"
		BestTokenValueName = BestTokenValueName.." (x25)"
	end
	if ( DFD_GetPrice(74846) * 25 ) > BestTokenValue then		
		BestTokenValue = ( DFD_GetPrice(74846) * 25 )
		_, BestTokenValueName = GetItemInfo(74846) -- "Witchberries (x25)"
		BestTokenValueName = BestTokenValueName.." (x25)"
	end
	if ( DFD_GetPrice(74847) * 25 ) > BestTokenValue then		
		BestTokenValue = ( DFD_GetPrice(74847) * 25 )
		_, BestTokenValueName = GetItemInfo(74847) -- "Jade Squash (x25)"
		BestTokenValueName = BestTokenValueName.." (x25)"
	end
	if ( DFD_GetPrice(74848) * 25 ) > BestTokenValue then		
		BestTokenValue = ( DFD_GetPrice(74848) * 25 )
		_, BestTokenValueName = GetItemInfo(74848) -- "Striped Melon (x25)"
		BestTokenValueName = BestTokenValueName.." (x25)"
	end
	if ( DFD_GetPrice(74849) * 25 ) > BestTokenValue then		
		BestTokenValue = ( DFD_GetPrice(74849) * 25 )
		_, BestTokenValueName = GetItemInfo(74849) -- "Pink Turnip (x25)"
		BestTokenValueName = BestTokenValueName.." (x25)"
	end
	if ( DFD_GetPrice(74850) * 25 ) > BestTokenValue then		
		BestTokenValue = ( DFD_GetPrice(74850) * 25 )
		_, BestTokenValueName = GetItemInfo(74850) -- "White Turnip (x25)"
		BestTokenValueName = BestTokenValueName.." (x25)"
	end
	if DFD_GetPrice(74853) > BestTokenValue then		
		BestTokenValue = DFD_GetPrice(74853)
		_, BestTokenValueName = GetItemInfo(74853) -- "100 Year Soy Sauce"
	end
	if ( DFD_GetPrice(74856) * 5 ) > BestTokenValue then		
		BestTokenValue = ( DFD_GetPrice(74856) * 5 )
		_, BestTokenValueName = GetItemInfo(74856) -- "Jade Lungfish (x5)"
		BestTokenValueName = BestTokenValueName.." (x5)"
	end
	if ( DFD_GetPrice(74857) * 5 ) > BestTokenValue then		
		BestTokenValue = ( DFD_GetPrice(74857) * 5 )
		_, BestTokenValueName = GetItemInfo(74857) -- "Giant Mantis Shrimp (x5)"
		BestTokenValueName = BestTokenValueName.." (x5)"
	end
	if ( DFD_GetPrice(74859) * 5 ) > BestTokenValue then		
		BestTokenValue = ( DFD_GetPrice(74859) * 5 )
		_, BestTokenValueName = GetItemInfo(74859) -- "Emperor Salmon (x5)"
		BestTokenValueName = BestTokenValueName.." (x5)"
	end
	if ( DFD_GetPrice(74860) * 5 ) > BestTokenValue then		
		BestTokenValue = ( DFD_GetPrice(74860) * 5 )
		_, BestTokenValueName = GetItemInfo(74860) -- "Redbelly Mandarin (x5)"
		BestTokenValueName = BestTokenValueName.." (x5)"
	end
	if ( DFD_GetPrice(74861) * 5 ) > BestTokenValue then		
		BestTokenValue = ( DFD_GetPrice(74861) * 5 )
		_, BestTokenValueName = GetItemInfo(74861) -- "Tiger Gourami (x5)"
		BestTokenValueName = BestTokenValueName.." (x5)"
	end
	if ( DFD_GetPrice(74864) * 5 ) > BestTokenValue then		
		BestTokenValue = ( DFD_GetPrice(74864) * 5 )
		_, BestTokenValueName = GetItemInfo(74864) -- "Reef Octopus (x5)"
		BestTokenValueName = BestTokenValueName.." (x5)"
	end
	if ( DFD_GetPrice(74865) * 5 ) > BestTokenValue then		
		BestTokenValue = ( DFD_GetPrice(74865) * 5 )
		_, BestTokenValueName = GetItemInfo(74865) -- "Krasarang Paddlefish (x5)"
		BestTokenValueName = BestTokenValueName.." (x5)"
	end
	if ( DFD_GetPrice(74866) * 5 ) > BestTokenValue then		
		BestTokenValue = ( DFD_GetPrice(74866) * 5 )
		_, BestTokenValueName = GetItemInfo(74866) -- "Golden Carp (x5)"
		BestTokenValueName = BestTokenValueName.." (x5)"
	end
	if ( DFD_GetPrice(74863) * 5 ) > BestTokenValue then		
		BestTokenValue = ( DFD_GetPrice(74863) * 5 )
		_, BestTokenValueName = GetItemInfo(74863) -- "Jewel Danio (x5)"
		BestTokenValueName = BestTokenValueName.." (x5)"
	end
	if ( DFD_GetPrice(75014) * 5 ) > BestTokenValue then		
		BestTokenValue = ( DFD_GetPrice(75014) * 5 )
		_, BestTokenValueName = GetItemInfo(75014) -- "Raw Crocolisk Belly (x5)"
		BestTokenValueName = BestTokenValueName.." (x5)"
	end
	return BestTokenValue, BestTokenValueName
end

function DFD_SpiritValue()
	BestSpiritValue, BestSpiritValueName = DFD_IronPawTokenValue()
	BestSpiritValueName = "an IronPaw Token in order to buy " .. BestSpiritValueName
	if ( ( (DFD_GetPrice(72235) * 20) + (DFD_GetPrice(79010) * 20) + (DFD_GetPrice(79011) * 20) + (DFD_GetPrice(72234) * 20) + (DFD_GetPrice(72237) * 20 ) ) / 5 ) > BestSpiritValue then		
		BestSpiritValue = ( (DFD_GetPrice(72235) * 20) + (DFD_GetPrice(79010) * 20) + (DFD_GetPrice(79011) * 20) + (DFD_GetPrice(72234) * 20) + (DFD_GetPrice(72237) * 20 ) ) / 5
		_, BestSpiritValueName = GetItemInfo(89610) -- "Pandaria Herbs" -- An average based on the assumption that you will average over time exactly 20 herbs per bag with an exactly even split between each of the five possible herbs.
	end
	if DFD_GetPrice(74247) > BestSpiritValue then		
		BestSpiritValue = DFD_GetPrice(74247)
		_, BestSpiritValueName = GetItemInfo(74247) -- "Ethereal Shard"
	end
	if ( DFD_GetPrice(72094) * 5 )> BestSpiritValue then		
		BestSpiritValue = ( DFD_GetPrice(72094) * 5 )
		_, BestSpiritValueName = GetItemInfo(72094) -- "Black Trillium Ore (x5)"
	end
	if ( DFD_GetPrice(72238) * 2 )> BestSpiritValue then		
		BestSpiritValue = ( DFD_GetPrice(72238) * 2 )
		_, BestSpiritValueName = GetItemInfo(72238) -- "Golden Lotus (x2)"
		BestSpiritValueName = BestSpiritValueName.." (x2)"
	end
	if ( DFD_GetPrice(72103) * 5 )> BestSpiritValue then		
		BestSpiritValue = ( DFD_GetPrice(72103) * 5 )
		_, BestSpiritValueName = GetItemInfo(72103) -- "White Trillium Ore (x5)"
		BestSpiritValueName = BestSpiritValueName.." (x5)"
	end
	if DFD_GetPrice(76734) > BestSpiritValue then		
		BestSpiritValue = DFD_GetPrice(76734)
		_, BestSpiritValueName = GetItemInfo(76734) -- "Serpent's Eye"
	end
	if ( DFD_GetPrice(72093) * 20 )> BestSpiritValue then		
		BestSpiritValue = ( DFD_GetPrice(72093) * 20 )
		_, BestSpiritValueName = GetItemInfo(72093) -- "Kyparite (x20)"
		BestSpiritValueName = BestSpiritValueName.." (x20)"
	end
	if ( DFD_GetPrice(79101) * 20 )> BestSpiritValue then		
		BestSpiritValue = ( DFD_GetPrice(79101) * 20 )
		_, BestSpiritValueName = GetItemInfo(79101) -- "Prismatic Scale (x20)"
		BestSpiritValueName = BestSpiritValueName.." (x20)"
	end
	if ( DFD_GetPrice(74250) * 5 )> BestSpiritValue then		
		BestSpiritValue = ( DFD_GetPrice(74250) * 5 )
		_, BestSpiritValueName = GetItemInfo(74250) -- "Mysterious Essence (x5)"
		BestSpiritValueName = BestSpiritValueName.." (x5)"
	end
	if ( DFD_GetPrice(72988) * 20 )> BestSpiritValue then		
		BestSpiritValue = ( DFD_GetPrice(72988) * 20 )
		_, BestSpiritValueName = GetItemInfo(72988) -- "Windwool Cloth (x20)"
		BestSpiritValueName = BestSpiritValueName.." (x20)"
	end
	if ( DFD_GetPrice(74249) * 20 )> BestSpiritValue then		
		BestSpiritValue = ( DFD_GetPrice(74249) * 20 )
		_, BestSpiritValueName = GetItemInfo(74249) -- "Spirit Dust (x20)"
		BestSpiritValueName = BestSpiritValueName.." (x20)"
	end
	if DFD_GetPrice(79255) > BestSpiritValue then		
		BestSpiritValue = DFD_GetPrice(79255)
		_, BestSpiritValueName = GetItemInfo(79255) -- "Starlight Ink"
	end
	if ( DFD_GetPrice(72092) * 20 )> BestSpiritValue then		
		BestSpiritValue = ( DFD_GetPrice(72092) * 20 )
		_, BestSpiritValueName = GetItemInfo(72092) -- "Ghost Iron Ore (x20)"
		BestSpiritValueName = BestSpiritValueName.." (x20)"
	end
	if ( DFD_GetPrice(72120) * 20 )> BestSpiritValue then		
		BestSpiritValue = ( DFD_GetPrice(72120) * 20 )
		_, BestSpiritValueName = GetItemInfo(72120) -- "Exotic Leather (x20)"
		BestSpiritValueName = BestSpiritValueName.." (x20)"
	end
	
	return BestSpiritValue, BestSpiritValueName
end

function DFD_SeedValue()
	BestSeedValue, BestSeedValueName = DFD_SpiritValue()
	BestSeedValue = BestSeedValue / 10
	_, SONGBELL_SEED = GetItemInfo(89233)
	_, SPIRIT_OF_HARMONY = GetItemInfo(76061)
	BestSeedValueName = SONGBELL_SEED.." (to convert 10 into a "..SPIRIT_OF_HARMONY.." to buy "..BestSeedValueName..")"
	if ( DFD_GetPrice(74840) * 5 ) > BestSeedValue then		
		BestSeedValue = ( DFD_GetPrice(74840) * 5 )
		_, BestSeedValueName = GetItemInfo(74840) -- "Green Cabbage Seeds"
	end
	if ( DFD_GetPrice(74841) * 5 ) > BestSeedValue then		
		BestSeedValue = ( DFD_GetPrice(74841) * 5 )
		_, BestSeedValueName = GetItemInfo(74841) -- "Juicycrunch Carrot Seeds"
	end
	if ( DFD_GetPrice(74842) * 5 ) > BestSeedValue then		
		BestSeedValue = ( DFD_GetPrice(74842) * 5 )
		_, BestSeedValueName = GetItemInfo(74842) -- "Mogu Pumpkin Seeds"
	end
	if ( DFD_GetPrice(74843) * 5 ) > BestSeedValue then		
		BestSeedValue = ( DFD_GetPrice(74843) * 5 )
		_, BestSeedValueName = GetItemInfo(74843) -- "Scallions Seeds"
	end
	if ( DFD_GetPrice(74844) * 5 ) > BestSeedValue then		
		BestSeedValue = ( DFD_GetPrice(74844) * 5 )
		_, BestSeedValueName = GetItemInfo(74844) -- "Red Blossom Leek Seeds"
	end
	if ( DFD_GetPrice(74846) * 5 ) > BestSeedValue then		
		BestSeedValue = ( DFD_GetPrice(74846) * 5 )
		_, BestSeedValueName = GetItemInfo(74846) -- "Witchberry Seeds"
	end
	if ( DFD_GetPrice(74847) * 5 ) > BestSeedValue then		
		BestSeedValue = ( DFD_GetPrice(74847) * 5 )
		_, BestSeedValueName = GetItemInfo(74847) -- "Jade Squash Seeds"
	end
	if ( DFD_GetPrice(74848) * 5 ) > BestSeedValue then		
		BestSeedValue = ( DFD_GetPrice(74848) * 5 )
		_, BestSeedValueName = GetItemInfo(74848) -- "Striped Melon Seeds"
	end
	if ( DFD_GetPrice(74849) * 5 ) > BestSeedValue then		
		BestSeedValue = ( DFD_GetPrice(74849) * 5 )
		_, BestSeedValueName = GetItemInfo(74849) -- "Pink Turnip Seeds"
	end
	if ( DFD_GetPrice(74850) * 5 ) > BestSeedValue then		
		BestSeedValue = ( DFD_GetPrice(74850) * 5 )
		_, BestSeedValueName = GetItemInfo(74850) -- "White Turnip Seeds"
	end
	if ( ( DFD_GetPrice(72235) * 3 + DFD_GetPrice(79010) * 3 + DFD_GetPrice(79011) * 3 + DFD_GetPrice(72234) * 3 + DFD_GetPrice(72237) * 3 ) / 5 ) > BestSeedValue then
		BestSeedValue = ( ( DFD_GetPrice(72235) * 3 + DFD_GetPrice(79010) * 3 + DFD_GetPrice(79011) * 3 + DFD_GetPrice(72234) * 3 + DFD_GetPrice(72237) * 3 ) / 5 )
		_, BestSeedValuename = GetItemInfo(85216) -- "Enigma Seeds" -- An average based on the assumption that you will average over time exactly 3 herbs per seed with an exactly even split between each of the five possible herbs.
	end
	if ( ( 3/4 * ( DFD_GetPrice(74249) * 4 ) ) + ( 1/4 * DFD_GetPrice(74250) ) ) > BestSeedValue then		
		BestSeedValue = ( ( 3/4 * ( DFD_GetPrice(74249) * 4 ) ) + ( 1/4 * DFD_GetPrice(74250) ) )
		_, BestSeedValueName = GetItemInfo(85217) -- "Magebulb Seeds" -- An average based on the assumption that you will average over time exactly 4x Spirit Dust per seed exactly 75% of the time and exactly 1x Mysterious Essence per seed exactly 25% of the time.
	end
	if DFD_GetPrice(72120) > BestSeedValue then		
		BestSeedValue = DFD_GetPrice(72120)
		_, BestSeedValueName = GetItemInfo(89202) -- "Raptorleaf Seeds" -- An average based on the assumption that you will average over time exactly 1 Exotic Leather per seed.
	end
	if ( DFD_GetPrice(72092) * 2 ) > BestSeedValue then		
		BestSeedValue = ( DFD_GetPrice(72092) * 2 )
		_, BestSeedValueName = GetItemInfo(85215) -- "Snakeroot Seeds" -- An average based on the assumption that you will average over time exactly 2 Ghost Iron Ore per seed.
	end
	if DFD_GetPrice(72988) > BestSeedValue then		
		BestSeedValue = DFD_GetPrice(72988)
		_, BestSeedValueName = GetItemInfo(89197) -- "Windshear Cactus Seeds" -- An average based on the assumption that you will average over time exactly 1 Windwool Cloth per seed.
	end
	return BestSeedValue, BestSeedValueName
end

function DFD_BonusSeedValue()
	BestSeedValue, BestSeedValueName = DFD_SeedValue()
	bonusintro = false
	function DFD_BonusIntro()
		if not bonusintro then
			DFD_JoguWhispers("But wait!  Have you come shpoken to me today?  If the watersh whishper that any of the following sheedsh have good (hic) conditionsh for tomorrow, plant them (hic) inshtead!")
			bonusintro = true
		end
	end

	totallinkstring = ""
	_, bonusitemlink = GetItemInfo(74840)
	if ( ( ( DFD_GetPrice(74840) * 7 ) > BestSeedValue ) and not ( BestSeedValueName == bonusitemlink ) ) then -- Green Cabbages
		DFD_BonusIntro()
		totallinkstring = bonusitemlink.." "..totallinkstring
	end

	_, bonusitemlink = GetItemInfo(74841)
	if ( ( ( DFD_GetPrice(74841) * 7 ) > BestSeedValue ) and not ( BestSeedValueName == bonusitemlink ) ) then -- Juicycrunch Carrots
		DFD_BonusIntro()
		totallinkstring = bonusitemlink.." (Mmm...Carrotsh...) "..totallinkstring
	end

	_, bonusitemlink = GetItemInfo(74842)
	if ( ( ( DFD_GetPrice(74842) * 7 ) > BestSeedValue ) and not ( BestSeedValueName == bonusitemlink ) ) then -- Mogu Pumpkins
		DFD_BonusIntro()
		totallinkstring = bonusitemlink.." "..totallinkstring
	end

	_, bonusitemlink = GetItemInfo(74842)
	if ( ( ( DFD_GetPrice(74843) * 7 ) > BestSeedValue ) and not ( BestSeedValueName == bonusitemlink ) ) then -- Scallions
		DFD_BonusIntro()
		totallinkstring = bonusitemlink.." "..totallinkstring
	end

	_, bonusitemlink = GetItemInfo(74844)
	if ( ( ( DFD_GetPrice(74844) * 7 ) > BestSeedValue ) and not ( BestSeedValueName == bonusitemlink ) ) then -- Red Blossom Leeks
		DFD_BonusIntro()
		totallinkstring = bonusitemlink.." "..totallinkstring
	end

	_, bonusitemlink = GetItemInfo(74846)
	if ( ( ( DFD_GetPrice(74846) * 7 ) > BestSeedValue ) and not ( BestSeedValueName == bonusitemlink ) ) then -- Witchberries
		DFD_BonusIntro()
		totallinkstring = bonusitemlink.." "..totallinkstring
	end

	_, bonusitemlink = GetItemInfo(74847)
	if ( ( ( DFD_GetPrice(74847) * 7 ) > BestSeedValue ) and not ( BestSeedValueName == bonusitemlink ) ) then -- Jade Squash
		DFD_BonusIntro()
		totallinkstring = bonusitemlink.." "..totallinkstring
	end
	
	_, bonusitemlink = GetItemInfo(74848)
	if ( ( ( DFD_GetPrice(74848) * 7 ) > BestSeedValue ) and not ( BestSeedValueName == bonusitemlink ) ) then -- Striped Melon Seeds
		DFD_BonusIntro()
		totallinkstring = bonusitemlink.." "..totallinkstring
	end
	
	_, bonusitemlink = GetItemInfo(74849)
	if ( ( ( DFD_GetPrice(74849) * 7 ) > BestSeedValue ) and not ( BestSeedValueName == bonusitemlink ) ) then -- Pink Turnip Seeds
		DFD_BonusIntro()
		totallinkstring = bonusitemlink.." "..totallinkstring
	end
	
	_, bonusitemlink = GetItemInfo(74850)
	if ( ( ( DFD_GetPrice(74850) * 7 ) > BestSeedValue ) and not ( BestSeedValueName == bonusitemlink ) ) then -- White Turnip Seeds
		DFD_BonusIntro()
		totallinkstring = bonusitemlink.." "..totallinkstring
	end
	if bonusintro then
		DFD_JoguWhispers(totallinkstring)
--		DFD_JoguWhispers("Don't forget this only worksh for the one the watersh whishper about AND you'll have to harvest them tomorrow for shure!  (hic)  Otherwishe, shtick to my first rec- (hic) rec- (hic) ...shuggeshun!")
	end
end